function [beta_ols sigma_ols log_like] = OLS_estimator(y,X,sn)
%%%% Computation of the OLS estimator and the corresponding likelihood
regime = max(sn);
T = max(size(y));
dimension = min(size(X));

beta_ols = zeros(dimension,regime);
SSR = zeros(regime,1);
sigma_ols = zeros(regime,1);
[tau] = trans_sn_into_cass(sn,T);
beta_ols(:,1) = (X(1:tau(1),:)'*X(1:tau(1),:))\X(1:tau(1),:)'*y(1:tau(1));
SSR(1) = (y(1:tau(1))-X(1:tau(1),:)*beta_ols(:,1))'*(y(1:tau(1))-X(1:tau(1),:)*beta_ols(:,1));
sigma_ols(1) = SSR(1)/(tau(1));
log_like = -0.5*tau(1)*log(2*pi*sigma_ols(1)) - 0.5*tau(1);




for k=2:regime
    beta_ols(:,k) = (X(tau(k-1)+1:tau(k),:)'*X(tau(k-1)+1:tau(k),:))\X(tau(k-1)+1:tau(k),:)'*y(tau(k-1)+1:tau(k));
    SSR(k) = (y(tau(k-1)+1:tau(k))-X(tau(k-1)+1:tau(k),:)*beta_ols(:,k))'*(y(tau(k-1)+1:tau(k))-X(tau(k-1)+1:tau(k),:)*beta_ols(:,k));
    sigma_ols(k) = SSR(k)/(tau(k)-tau(k-1));
    log_like = log_like -0.5*(tau(k)-tau(k-1))*log(2*pi*sigma_ols(k)) - 0.5*(tau(k)-tau(k-1));
end